#pragma once

#include "OSAbstract/OSAbstract.h"

#define XI_006AE_VENDOR_ID		0x1172
#define XI_006AE_DEVICE_ID		0xA006
#define XI006AE_INFO 			"XI006AE"

typedef struct _xi006ae XI006AE;
typedef enum _XI006AE_AUDIO_INDEX {
	XI006AE_INDEX_A1,
	XI006AE_INDEX_A2,
	XI006AE_INDEX_A3,
	XI006AE_INDEX_A4,
	XI006AE_INDEX_A5,
	XI006AE_INDEX_A6,
	XI006AE_NUM_AUDIO_DEVICES
} XI006AE_AUDIO_INDEX;

typedef enum _XI006AE_VIDEO_INDEX {
	XI006AE_INDEX_V1,
	XI006AE_INDEX_V2,
	XI006AE_INDEX_V3,
	XI006AE_INDEX_V4,
	XI006AE_INDEX_V5,
	XI006AE_INDEX_V6,
	XI006AE_NUM_VIDEO_DEVICES
} XI006AE_VIDEO_INDEX;

XI006AE *XI006AE_Create(void);
void XI006AE_Destroy(XI006AE *xi);
int XI006AE_OnPowerUp(XI006AE *xi, uint8_t *bmmio, void *pci);
uint8_t * XI006AE_OnPowerDown(XI006AE *xi, void *pci);
int XI006AE_Interrupter(XI006AE *xi);

void * XI006AE_GetV4l2ListHead(XI006AE *xi);
void XI006AE_GetSignalInfo(XI006AE *xi, int channal,VideoSignalInfo *pInfo);
void XI006AE_SetVideoShowInfo(XI006AE *xi, int channal, VideoShowInfo *pInfo);
int XI006AE_WaitForNewImage(XI006AE *xi, int channal);
int XI006AE_ProcessOneImage(XI006AE *xi, int channal, uint8_t * pbDestBuf);

void XI006AE_VSetSquareMode(XI006AE *xi, int channal, bool v);
void XI006AE_VSetPreDenoiseThreshold(XI006AE *xi, int channal, uint8_t v);
void XI006AE_VSetPostDenoiseThreshold(XI006AE *xi, int channal, uint8_t v);
void XI006AE_VSetLumaPeakingGain(XI006AE *xi, int channal, uint8_t v);
void XI006AE_VSetAGCMode(XI006AE *xi, int channal, uint8_t v);
void XI006AE_VSetLumaGain(XI006AE *xi, int channal, int v);
void XI006AE_VSetChromaGain(XI006AE *xi, int channal, int v);
void XI006AE_VSetContrast(XI006AE *xi, int channal, int v);
void XI006AE_VSetBrightness(XI006AE *xi, int channal, int v);
void XI006AE_VSetHue(XI006AE *xi, int channal, int v);
void XI006AE_VSetSaturation(XI006AE *xi, int channal, int v);
void XI006AE_VSetSharpness(XI006AE *xi, int channal, int v);
void XI006AE_VGetLumaGain(XI006AE *xi, int channal, int *pv);
void XI006AE_VGetChromaGain(XI006AE *xi, int channal, int *pv);
void XI006AE_VSetDeinterlaceMethod(XI006AE *xi, int channal, DEINTERLACE_TYPE type);
void XI006AE_VSetScaleMode(XI006AE *xi, int channal, SCALEP_TYPE type);
void XI006AE_VSetVerticalFlip(XI006AE *xi, int channal, bool type);
void XI006AE_VSetHorizontalFlip(XI006AE *xi, int channal, bool type);

void * XI006AE_GetAlsaListHead(XI006AE *xi);
uint32_t XI006AE_ADefaultOSRingBufSize(XI006AE *xi, int channal);
void XI006AE_AStart(XI006AE *xi, int channal, uint8_t *pOSRingBufBase, uint32_t cbOSRingBufSize);
void XI006AE_AStop(XI006AE *xi, int channal);
uint32_t XI006AE_ACapture(XI006AE *xi, int channal);
uint32_t XI006AE_AGetOSRingBufWPos(XI006AE *xi, int channal);

uint8_t XI006AE_AGetMaxVolume(void);
long XI006AE_AGetLVolume(XI006AE *xi, int channal);
long XI006AE_AGetRVolume(XI006AE *xi, int channal);
void XI006AE_ASetLVolume(XI006AE *xi, int channal, long l);
void XI006AE_ASetRVolume(XI006AE *xi, int channal, long r);
bool XI006AE_AGetLMute(XI006AE *xi, int channal);
bool XI006AE_AGetRMute(XI006AE *xi, int channal);
void XI006AE_ASetLMute(XI006AE *xi, int channal, bool l);
void XI006AE_ASetRMute(XI006AE *xi, int channal, bool r);
