#pragma once

#include "OSAbstract/OSAbstract.h"

#define XI_100XE_VENDOR_ID			0x1172
#define XI_100XE_DEVICE_ID			0xE100
#define XI100XE_AUDIO_DEVICE_COUNT	1
#define XI100XE_VIDEO_DEVICE_COUNT	1

typedef struct _XI100XEDevice XI100XEDevice;
typedef struct _XI100XEDevice XI100XE;

//////////////////////////////////////////////////////
//// XI100XEDevice Implement interface
XI100XEDevice *XI100XE_Create(void);
void XI100XE_Destroy(XI100XEDevice *xe);
int XI100XE_OnPowerUp(XI100XEDevice *xe, uint8_t *bmmio, void *pci);
unsigned char * XI100XE_OnPowerDown(XI100XEDevice *xe, void *pci);
bool XI100XE_OnInterrupt(XI100XEDevice *xe);
void * XI100XE_GetAlsaListHead(XI100XEDevice *xe);
void * XI100XE_GetV4l2ListHead(XI100XEDevice *xe);
unsigned char * XI100XEDevice_GetROMID(XI100XEDevice *xe, unsigned int * length);
bool XI100XE_IsDeviceValid(XI100XEDevice *xe);

//////////////////////////////////////////////////////
//// Video Implement interface
void XI100XEDevice_GetInputSignal(
			XI100XEDevice *xe, 
			int32_t *lImageFormatVersion, 
			bool* bInterlaced, 
			int* cx, 
			int* cy, 
			VINEX_FORMAT* format, 
			bool* bPrescaled, 
			int* cxScaled, 
			bool *bHasSignal
			);
int XI100XEDevice_SetVideoShowInfo(XI100XEDevice *xe, bool bBottomUp, int csOutput, long width, long height);
int XI100XEDevice_WaitForNewImage(XI100XEDevice *xe, uint32_t dwTimeoutJiff);
int XI100XEDevice_ProcessOneFrame(XI100XEDevice *xe, uint8_t * pbDestBuf);

///////////////////////////////////////////////////////
//// Video control interface
long XI100XEDevice_GetBrightness(XI100XEDevice *xe);
int XI100XEDevice_SetBrightness(XI100XEDevice *xe, long brightness);
long XI100XEDevice_GetContrast(XI100XEDevice *xe);
int XI100XEDevice_SetContrast(XI100XEDevice *xe, long contrast);
long XI100XEDevice_GetHue(XI100XEDevice *xe);
int XI100XEDevice_SetHue(XI100XEDevice *xe, long hue);
long XI100XEDevice_GetSaturation(XI100XEDevice *xe);
int XI100XEDevice_SetSaturation(XI100XEDevice *xe, long saturation);
long XI100XEDevice_GetSharpness(XI100XEDevice *xe);
int XI100XEDevice_SetSharpness(XI100XEDevice *xe, long sharpness);
long XI100XEDevice_GetGamma(XI100XEDevice *xe);
int XI100XEDevice_SetGamma(XI100XEDevice *xe, long gamma);
bool XI100XEDevice_IsVerticalFlip(XI100XEDevice *xe);
void XI100XEDevice_SetHorizontalFlip(XI100XEDevice *xe, bool flip);
void XI100XEDevice_SetVerticalFlip(XI100XEDevice *xe, bool flip);
void XI100XEDevice_SetDeinterlaceMethod(XI100XEDevice *xe, int method);
void XI100XEDevice_SetScaleMode(XI100XEDevice *xe, int mode);
HDCAPTURE_MODE XI100XEDevice_GetCaptureMode(XI100XEDevice *xe);
int XI100XEDevice_SetCaptureMode(XI100XEDevice *xe, HDCAPTURE_MODE mode);
long XI100XEDevice_GetCapturePhase(XI100XEDevice *xe);
int XI100XEDevice_SetCapturePhase(XI100XEDevice *xe,long pPhase);
int XI100XEDevice_SetHDCaptureTriggerAutoPosition(XI100XEDevice *xe);
void XI100XE_SetAutoDetectCaptureMode(XI100XEDevice *xe, bool Auto);
bool XI100XE_GetAutoDetectCaptureMode(XI100XEDevice *xe);
HDCAPTURE_MODE XI100XE_GetInitialCaptureMode(XI100XEDevice *xe);
bool XI100XE_GetInitialAutoDetectCaptureMode(XI100XEDevice *xe);
int XI100XE_GetNumberOfVideoResolutions(XI100XEDevice *xe);
VIDEO_RESOLUTION * XI100XE_GetVideoResolutions(XI100XEDevice *xe);

//////////////////////////////////////////////////////////
//// Audio Implement Interface
void XI100XEDevice_AStart(XI100XEDevice *xe, uint8_t *pOSRingBufBase, uint32_t cbOSRingBufSize);
void XI100XEDevice_AStop(XI100XEDevice *xe);
uint32_t XI100XEDevice_ACapture(XI100XEDevice *xe);
uint32_t XI100XEDevice_AGetOSRingBufWPos(XI100XEDevice *xe);
uint32_t XI100XEDevice_ADefaultOSRingBufSize(XI100XEDevice *xe);

///////////////////////////////////////////////////////
//// Audio Control Implement Interface
long XI100XEDevice_GetHDMIRVolume(XI100XEDevice *xe);
long XI100XEDevice_GetALVolume(XI100XEDevice *xe);
long XI100XEDevice_GetARVolume(XI100XEDevice *xe);
void XI100XEDevice_SetHDMILVolume(XI100XEDevice *xe, long value);
long XI100XEDevice_GetHDMILVolume(XI100XEDevice *xe);
void XI100XEDevice_SetHDMIRVolume(XI100XEDevice *xe, long value);
void XI100XEDevice_SetALVolume(XI100XEDevice *xe, long value);
void XI100XEDevice_SetARVolume(XI100XEDevice *xe, long value);
bool XI100XEDevice_GetHDMILMute(XI100XEDevice *xe);
bool XI100XEDevice_GetHDMIRMute(XI100XEDevice *xe);
bool XI100XEDevice_GetALMute(XI100XEDevice *xe);
bool XI100XEDevice_GetARMute(XI100XEDevice *xe);
void XI100XEDevice_SetHDMILMute(XI100XEDevice *xe, bool mute);
void XI100XEDevice_SetHDMIRMute(XI100XEDevice *xe, bool mute);
void XI100XEDevice_SetALMute(XI100XEDevice *xe, bool mute);
void XI100XEDevice_SetARMute(XI100XEDevice *xe, bool mute);
