#pragma once

#include "OSAbstract/OSAbstract.h"

#define XI102XE_VENDOR_ID_PUBLIC		0x1172
#define XI102XE_DEVICE_ID_PUBLIC		0xD102
#define XI102XE_AUDIO_DEVICE_COUNT		3
#define XI102XE_VIDEO_DEVICE_COUNT		3

typedef enum _XI102XE_VINDEX {
	XI102XE_HDMI_INDEX_0,
	XI102XE_SDI_INDEX_0,
	XI102XE_SDI_INDEX_1,
	XI102XE_VINDEX_MAX
}XI102XE_VINDEX;

typedef struct _XI102XEHDDevice XI102XEHD;

XI102XEHD *XI102XEHD_Create(void);
void XI102XEHD_Destroy(XI102XEHD *pXI102XEHDHD);
int XI102XEHD_OnPowerUp(XI102XEHD * pXI102XEHD , uint8_t *bmmio, void *pci);
unsigned char * XI102XEHD_OnPowerDown(XI102XEHD * pXI102XEHD , void *pci);
bool XI102XEHD_OnInterrupt(XI102XEHD * pXI102XEHD);
void * XI102XEHD_GetAlsaListHead(XI102XEHD * pXI102XEHD);
void * XI102XEHD_GetV4l2ListHead(XI102XEHD * pXI102XEHD);
unsigned char * XI102XEHD_GetROMID(XI102XEHD *pXI102XEHD, unsigned int * length);
bool XI102XEHD_IsDeviceValid(XI102XEHD *pXI102XEHD);

////////////////////////////////////////////////////////////////////////////////
//// Video Implement interface
void XI102XEHD_GetInputSignal(
			XI102XEHD *pXI102XEHD, 
			XI102XE_VINDEX index,
			long *lImageFormatVersion, 
			bool* bInterlaced, 
			int* cx, 
			int* cy, 
			VINEX_FORMAT* format, 
			bool* bPrescaled, 
			int* cxScaled, 
			bool *bHasSignal
			);
int XI102XEHD_SetVideoShowInfo(
				XI102XEHD *pXI102XEHD, 
				XI102XE_VINDEX index, 
				bool bBottomUp, 
				int csOutput, 
				long width, 
				long height
				);
int XI102XEHD_WaitForNewImage(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, uint32_t dwTimeoutJiff);
int XI102XEHD_ProcessOneFrame(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, uint8_t * pbDestBuf);
////////////////////////////////////////////////////////////////////////////////
//// Audio Implement interface
int XI102XEHD_AudioCaptureStart(
				XI102XEHD *pXI102XEHD, 
				XI102XE_VINDEX index, 
				uint8_t * pOSRingBufBase, 
				uint32_t cbOSRingBufSize
				);
int XI102XEHD_AudioCaptureStop(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
uint32_t XI102XEHD_AudioCapture(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
uint32_t XI102XEHD_AudioGetOSRingBufWPos(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
uint32_t XI102XEHD_AudioCaptureDefaultOSRingBufSize(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);

////////////////////////////////////////////////////////////////////////////////
//// interface ioctl
long XI102XEHD_GetVolume(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, bool left);
long XI102XEHD_SetVolume(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, bool left, long value);
int XI102XEHD_GetMute(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, bool left);
int XI102XEHD_SetMute(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, bool left, long value);
int XI102XEHD_IsAudioSampleRateChanged(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
int XI102XEHD_GetAudioSampleRate(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
int XI102XEHD_GetSignalInfo(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index,VIDEO_SIGNAL_INFO *pSignal);
int XI102XEHD_SetDeinterlaceMethod(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, int method);
int XI102XEHD_SetScaleMode(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, int method);
int XI102XEHD_IsVerticalFlip(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
int XI102XEHD_SetVerticalFlip(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, bool flip);
int XI102XEHD_IsHorizontalFlip(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
int XI102XEHD_SetHorizontalFlip(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, bool flip);
long XI102XEHD_GetBrightness(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
long XI102XEHD_SetBrightness(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, long val);
long XI102XEHD_GetContrast(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
long XI102XEHD_SetContrast(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, long val);
long XI102XEHD_GetHue(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
long XI102XEHD_SetHue(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, long val);
long XI102XEHD_GetSaturation(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
long XI102XEHD_SetSaturation(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, long val);
long XI102XEHD_GetSharpness(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
long XI102XEHD_SetSharpness(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, long val);
long XI102XEHD_GetPhase(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
long XI102XEHD_SetPhase(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, long val);
long XI102XEHD_GetFormat(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
long XI102XEHD_SetFormat(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, VINEX_FORMAT format);
long XI102XEHD_SetAutoDetectCaptureMode(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, bool bAutoDetect);
long XI102XEHD_GetAutoDetectCaptureMode(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
long XI102XEHD_SetCaptureMode(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index , HDCAPTURE_MODE mode);
long XI102XEHD_GetCaptureMode(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
int XI102XEHD_TriggerAutoPhase(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
int XI102XEHD_TriggerAutoPosition(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
int XI102XEHD_IsHDCPSignal(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index);
int XI102XEHD_HDCPIsOn(XI102XEHD *pXI102XEHD, XI102XE_VINDEX index, bool on);
