#pragma once

#include "OSAbstract/OSAbstract.h"

#define XI200DE_VENDOR_ID					0x1172
#define XI200DE_DEVICE_ID					0xD200
#define XI200DE_AUDIO_DEVICE_COUNT			2
#define XI200DE_VIDEO_DEVICE_COUNT			2

typedef  enum _XI200DE_HDMI_INDEX {
	XI200DE_HDMI_INDEX1,
	XI200DE_HDMI_INDEX2,
	XI200DE_HDMI_NUM_DEVICES
}XI200DE_HDMI_INDEX;

typedef struct _XI200DEHDMIDevice XI200DEHDMIDevice;

XI200DEHDMIDevice *XI200DEHDMIDevice_Create(void);
void XI200DEHDMIDevice_Destroy(XI200DEHDMIDevice *pXI200DEHDMIDevice);
int XI200DEHDMIDevice_OnPowerUp(XI200DEHDMIDevice * pXI200DEHDMIDevice , uint8_t *bmmio, void *pci);
unsigned char * XI200DEHDMIDevice_OnPowerDown(XI200DEHDMIDevice * pXI200DEHDMIDevice , void *pci);
bool XI200DEHDMIDevice_OnInterrupt(XI200DEHDMIDevice * pXI200DEHDMIDevice);
void * XI200DEHDMIDevice_GetAlsaListHead(XI200DEHDMIDevice * pXI200DEHDMIDevice);
void * XI200DEHDMIDevice_GetV4l2ListHead(XI200DEHDMIDevice * pXI200DEHDMIDevice);
unsigned char * XI200DEHDMIDevice_GetROMID(XI200DEHDMIDevice *pXI200DEHDMIDevice, unsigned int * length);
bool XI200DEHDMIDevice_IsDeviceValid(XI200DEHDMIDevice *pXI200DEHDMIDevice);

////////////////////////////////////////////////////////////////////////////////
//// Video Implement interface
void XI200DEHDMIDevice_GetInputSignal(
			XI200DEHDMIDevice *pXI200DEHDMIDevice, 
			XI200DE_HDMI_INDEX index,
			long *lImageFormatVersion, 
			bool* bInterlaced, 
			int* cx, 
			int* cy, 
			VINEX_FORMAT* format, 
			bool* bPrescaled, 
			int* cxScaled, 
			bool *bHasSignal
			);
int XI200DEHDMIDevice_SetVideoShowInfo(
				XI200DEHDMIDevice *pXI200DEHDMIDevice, 
				XI200DE_HDMI_INDEX index, 
				bool bBottomUp, 
				int csOutput, 
				long width, 
				long height
				);
int XI200DEHDMIDevice_WaitForNewImage(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, uint32_t dwTimeoutJiff);
int XI200DEHDMIDevice_ProcessOneFrame(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, uint8_t * pbDestBuf);
////////////////////////////////////////////////////////////////////////////////
//// Audio Implement interface
int XI200DEHDMIDevice_AudioCaptureStart(
				XI200DEHDMIDevice *pXI200DEHDMIDevice, 
				XI200DE_HDMI_INDEX index, 
				uint8_t * pOSRingBufBase, 
				uint32_t cbOSRingBufSize
				);
int XI200DEHDMIDevice_AudioCaptureStop(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
uint32_t XI200DEHDMIDevice_AudioCapture(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
uint32_t XI200DEHDMIDevice_AudioGetOSRingBufWPos(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
uint32_t XI200DEHDMIDevice_AudioCaptureDefaultOSRingBufSize(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);

////////////////////////////////////////////////////////////////////////////////
//// interface ioctl
long XI200DEHDMIDevice_GetVolume(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, bool left);
long XI200DEHDMIDevice_SetVolume(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, bool left, long value);
int XI200DEHDMIDevice_GetMute(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, bool left);
int XI200DEHDMIDevice_SetMute(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, bool left, long value);
int XI200DEHDMIDevice_IsAudioSampleRateChanged(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
int XI200DEHDMIDevice_GetAudioSampleRate(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
int XI200DEHDMIDevice_GetSignalInfo(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index,VIDEO_SIGNAL_INFO *pSignal);
int XI200DEHDMIDevice_SetDeinterlaceMethod(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, int method);
int XI200DEHDMIDevice_SetScaleMode(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, int method);
int XI200DEHDMIDevice_IsVerticalFlip(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
int XI200DEHDMIDevice_SetVerticalFlip(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, bool flip);
int XI200DEHDMIDevice_IsHorizontalFlip(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
int XI200DEHDMIDevice_SetHorizontalFlip(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, bool flip);
long XI200DEHDMIDevice_GetBrightness(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
long XI200DEHDMIDevice_SetBrightness(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, long val);
long XI200DEHDMIDevice_GetContrast(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
long XI200DEHDMIDevice_SetContrast(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, long val);
long XI200DEHDMIDevice_GetHue(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
long XI200DEHDMIDevice_SetHue(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, long val);
long XI200DEHDMIDevice_GetSaturation(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
long XI200DEHDMIDevice_SetSaturation(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, long val);
long XI200DEHDMIDevice_GetSharpness(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
long XI200DEHDMIDevice_SetSharpness(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, long val);
long XI200DEHDMIDevice_GetPhase(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
long XI200DEHDMIDevice_SetPhase(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, long val);
long XI200DEHDMIDevice_GetFormat(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
long XI200DEHDMIDevice_SetFormat(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, VINEX_FORMAT format);
long XI200DEHDMIDevice_SetAutoDetectCaptureMode(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, bool bAutoDetect);
long XI200DEHDMIDevice_GetAutoDetectCaptureMode(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
long XI200DEHDMIDevice_SetCaptureMode(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index , HDCAPTURE_MODE mode);
long XI200DEHDMIDevice_GetCaptureMode(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
int XI200DEHDMIDevice_TriggerAutoPhase(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
int XI200DEHDMIDevice_TriggerAutoPosition(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
int XI200DEHDMIDevice_IsHDCPSignal(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index);
int XI200DEHDMIDevice_HDCPIsOn(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, bool on);
int XI200DEHDMIDevice_LowLatencyMode(XI200DEHDMIDevice *pXI200DEHDMIDevice, XI200DE_HDMI_INDEX index, bool enable);
