#pragma once

#include "OSAbstract/OSAbstract.h"

#define XI400DE_VENDOR_ID					0x1172
#define XI400DE_DEVICE_ID					0xD400
#define XI400DE_AUDIO_DEVICE_COUNT			4
#define XI400DE_VIDEO_DEVICE_COUNT			4

typedef  enum _XI400DE_HDMI_INDEX {
	XI400DE_HDMI_INDEX1,
	XI400DE_HDMI_INDEX2,
	XI400DE_HDMI_INDEX3,
	XI400DE_HDMI_INDEX4,
	XI400DE_HDMI_NUM_DEVICES
}XI400DE_HDMI_INDEX;

/*
typedef enum _XI400DE_HDMI_HDVIDEO_INDEX {
	XI400DE_HDMI_INDEX_HDVideo1,
	XI400DE_HDMI_INDEX_HDVideo2,
	XI400DE_HDMI_INDEX_HDVideo3,
	XI400DE_HDMI_INDEX_HDVideo4,
	XI400DE_HDMI_NUM_HDVIDEO_DEVICES
}XI400DE_HDMI_HDVIDEO_INDEX;
*/

typedef struct _XI400DEHDMIDevice XI400DEHDMIDevice;

XI400DEHDMIDevice *XI400DEHDMIDevice_Create(void);
void XI400DEHDMIDevice_Destroy(XI400DEHDMIDevice *pXI400DEHDMIDevice);
int XI400DEHDMIDevice_OnPowerUp(XI400DEHDMIDevice * pXI400DEHDMIDevice , uint8_t *bmmio, void *pci);
unsigned char * XI400DEHDMIDevice_OnPowerDown(XI400DEHDMIDevice * pXI400DEHDMIDevice , void *pci);
bool XI400DEHDMIDevice_OnInterrupt(XI400DEHDMIDevice * pXI400DEHDMIDevice);
void * XI400DEHDMIDevice_GetAlsaListHead(XI400DEHDMIDevice * pXI400DEHDMIDevice);
void * XI400DEHDMIDevice_GetV4l2ListHead(XI400DEHDMIDevice * pXI400DEHDMIDevice);
unsigned char * XI400DEHDMIDevice_GetROMID(XI400DEHDMIDevice *pXI400DEHDMIDevice, unsigned int * length);
bool XI400DEHDMIDevice_IsDeviceValid(XI400DEHDMIDevice *pXI400DEHDMIDevice);

////////////////////////////////////////////////////////////////////////////////
//// Video Implement interface
void XI400DEHDMIDevice_GetInputSignal(
			XI400DEHDMIDevice *pXI400DEHDMIDevice, 
			XI400DE_HDMI_INDEX index,
			long *lImageFormatVersion, 
			bool* bInterlaced, 
			int* cx, 
			int* cy, 
			VINEX_FORMAT* format, 
			bool* bPrescaled, 
			int* cxScaled, 
			bool *bHasSignal
			);
int XI400DEHDMIDevice_SetVideoShowInfo(
				XI400DEHDMIDevice *pXI400DEHDMIDevice, 
				XI400DE_HDMI_INDEX index, 
				bool bBottomUp, 
				int csOutput, 
				long width, 
				long height
				);
int XI400DEHDMIDevice_WaitForNewImage(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, uint32_t dwTimeoutJiff);
int XI400DEHDMIDevice_ProcessOneFrame(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, uint8_t * pbDestBuf);
////////////////////////////////////////////////////////////////////////////////
//// Audio Implement interface
int XI400DEHDMIDevice_AudioCaptureStart(
				XI400DEHDMIDevice *pXI400DEHDMIDevice, 
				XI400DE_HDMI_INDEX index, 
				uint8_t * pOSRingBufBase, 
				uint32_t cbOSRingBufSize
				);
int XI400DEHDMIDevice_AudioCaptureStop(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
uint32_t XI400DEHDMIDevice_AudioCapture(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
uint32_t XI400DEHDMIDevice_AudioGetOSRingBufWPos(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
uint32_t XI400DEHDMIDevice_AudioCaptureDefaultOSRingBufSize(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);

////////////////////////////////////////////////////////////////////////////////
//// interface ioctl
long XI400DEHDMIDevice_GetVolume(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, bool left);
long XI400DEHDMIDevice_SetVolume(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, bool left, long value);
int XI400DEHDMIDevice_GetMute(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, bool left);
int XI400DEHDMIDevice_SetMute(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, bool left, long value);
int XI400DEHDMIDevice_IsAudioSampleRateChanged(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
int XI400DEHDMIDevice_GetAudioSampleRate(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
int XI400DEHDMIDevice_GetSignalInfo(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index,VIDEO_SIGNAL_INFO *pSignal);
int XI400DEHDMIDevice_SetDeinterlaceMethod(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, int method);
int XI400DEHDMIDevice_SetScaleMode(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, int method);
int XI400DEHDMIDevice_IsVerticalFlip(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
int XI400DEHDMIDevice_SetVerticalFlip(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, bool flip);
int XI400DEHDMIDevice_IsHorizontalFlip(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
int XI400DEHDMIDevice_SetHorizontalFlip(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, bool flip);
long XI400DEHDMIDevice_GetBrightness(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
long XI400DEHDMIDevice_SetBrightness(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, long val);
long XI400DEHDMIDevice_GetContrast(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
long XI400DEHDMIDevice_SetContrast(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, long val);
long XI400DEHDMIDevice_GetHue(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
long XI400DEHDMIDevice_SetHue(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, long val);
long XI400DEHDMIDevice_GetSaturation(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
long XI400DEHDMIDevice_SetSaturation(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, long val);
long XI400DEHDMIDevice_GetSharpness(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
long XI400DEHDMIDevice_SetSharpness(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, long val);
long XI400DEHDMIDevice_GetPhase(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
long XI400DEHDMIDevice_SetPhase(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, long val);
long XI400DEHDMIDevice_GetFormat(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
long XI400DEHDMIDevice_SetFormat(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, VINEX_FORMAT format);
long XI400DEHDMIDevice_SetAutoDetectCaptureMode(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, bool bAutoDetect);
long XI400DEHDMIDevice_GetAutoDetectCaptureMode(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
long XI400DEHDMIDevice_SetCaptureMode(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index , HDCAPTURE_MODE mode);
long XI400DEHDMIDevice_GetCaptureMode(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
int XI400DEHDMIDevice_TriggerAutoPhase(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
int XI400DEHDMIDevice_TriggerAutoPosition(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
int XI400DEHDMIDevice_IsHDCPSignal(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index);
int XI400DEHDMIDevice_HDCPIsOn(XI400DEHDMIDevice *pXI400DEHDMIDevice, XI400DE_HDMI_INDEX index, bool on);
