#pragma once

#include <linux/videodev2.h>
#include "PublicCtrl.h"

#ifndef WINDOW_TYPE
#define HANDLE            	int
#define MAX_PATH        	260
#define TRUE                true  
#define FALSE               false 
#define __stdcall 
#define __declspec(x)   
#define __cdecl  

typedef bool                BOOL;
typedef unsigned char       BYTE;
typedef float        		FLOAT;
typedef FLOAT           	*PFLOAT;
typedef char           		CHAR; 
typedef unsigned char       UCHAR;
typedef unsigned char       *PUCHAR;
typedef short         		SHORT; 
typedef unsigned short      USHORT;
typedef unsigned short      *PUSHORT;
typedef long     			LONG; 
typedef unsigned short      WORD;
typedef unsigned long       DWORD;
typedef long long        	LONGLONG;
typedef unsigned long long  ULONGLONG; 
typedef ULONGLONG           *PULONGLONG;
typedef unsigned long       ULONG; 
typedef int                 INT;
typedef unsigned int        UINT;
typedef unsigned int        *PUINT; 
typedef void                VOID;

typedef char     			*LPSTR; 
typedef const char         	*LPCSTR; 
typedef DWORD              	*LPDWORD; 
typedef unsigned long      	UINT_PTR; 
typedef UINT_PTR           	SIZE_T; 
typedef LONGLONG           	USN;
typedef BYTE               	BOOLEAN;
typedef void               	*PVOID;

typedef struct _FILETIME {
	DWORD dwLowDateTime;
	DWORD dwHighDateTime;
}FILETIME;

typedef union _ULARGE_INTEGER {
	struct {
		DWORD LowPart;
		DWORD HighPart;
	};
	struct {
		DWORD LowPart;
		DWORD HighPart;
	} u;
	ULONGLONG QuadPart;
} ULARGE_INTEGER, *PULARGE_INTEGER;
#endif 

#ifdef __i386__
#undef OS_INT_PTR
#define OS_INT_PTR int32_t
#endif

#ifdef __amd64__
#undef OS_INT_PTR
#define OS_INT_PTR int64_t
#endif

typedef enum _IRQ_RET_TYPE
{
	IRQ_RET_NO_INT 		 = 0x1,
	IRQ_RET_LOST_SYNC	 = 0x2,
	IRQ_RET_SIZE_CHANGED = 0x4,
	IRQ_RET_NEW_IMAGE	 = 0x8
}IRQ_RET_TYPE;

typedef enum _SCALEP_TYPE
{
    SCALEP_TYPE_SQEEZE,
    SCALEP_TYPE_LETTER_BOX,
    SCALEP_TYPE_EDGE_CROP,
	SCALEP_TYPE_MIN = SCALEP_TYPE_SQEEZE,
	SCALEP_TYPE_MAX = SCALEP_TYPE_EDGE_CROP	
} SCALEP_TYPE;

typedef enum _DEINTERLACE_TYPE
{
    DEINTERLACE_NONE,
    DEINTERLACE_BLEND
} DEINTERLACE_TYPE;

typedef enum _YUVMODE {
	YUVMODE_AUTO,
	YUVMODE_709,
	YUVMODE_601
}YUVMODE;

typedef enum _IMAGE_STATUS{
	IMAGE_ID_NONE = -1,
	IMAGE_ID_LEGAL_NOTICE = 0,
	IMAGE_ID_NO_SIGNAL = 1,
	IMAGE_ID_UNSUPPORTED_SIGNAL = 2
}IMAGE_STATUS;

typedef enum _ADV7180_VIDEO_STANDARD_MODE {
	ADV7180_VIDEO_STANDARD_NTSC_M,
	ADV7180_VIDEO_STANDARD_NTSC_443,
	ADV7180_VIDEO_STANDARD_PAL_D,
	ADV7180_VIDEO_STANDARD_PAL_M,
	ADV7180_VIDEO_STANDARD_PAL_N_COMBO,
	ADV7180_VIDEO_STANDARD_PAL_60,
	ADV7180_VIDEO_STANDARD_SECAM_B,
	ADV7180_VIDEO_STANDARD_SECAM_D,
	ADV7180_VIDEO_STANDARD_NONE
	/*
	ADV7180_VIDEO_STANDARD_AUTO_PAL_BGHID_NTSC_J_SECAM,
	ADV7180_VIDEO_STANDARD_AUTO_PAL_BGHID_NTSC_M_SECAM,
	ADV7180_VIDEO_STANDARD_AUTO_PAL_N_NTSC_J_SECAM,
	ADV7180_VIDEO_STANDARD_AUTO_PAL_N_NTSC_M_SECAM,
	ADV7180_VIDEO_STANDARD_NTSC_J,
	ADV7180_VIDEO_STANDARD_NTSC_M,
	ADV7180_VIDEO_STANDARD_PAL_60,
	ADV7180_VIDEO_STANDARD_NTSC_443,
	ADV7180_VIDEO_STANDARD_PAL_BGHID,
	ADV7180_VIDEO_STANDARD_PAL_N,
	ADV7180_VIDEO_STANDARD_PAL_M,
	ADV7180_VIDEO_STANDARD_PAL_M_PEDESTAL,
	ADV7180_VIDEO_STANDARD_PAL_N_COMBO,
	ADV7180_VIDEO_STANDARD_PAL_N_COMBO_PEDESTAL,
	ADV7180_VIDEO_STANDARD_SECAM,
	ADV7180_VIDEO_STANDARD_SECAM_PEDESTAL,
	ADV7180_VIDEO_STANDARD_NONE
	 */
} ADV7180_VIDEO_STANDARD_MODE;

static inline void Enum_Video_Standard_Mode(void) 
{
	printk(KERN_INFO "0: \t ADV7180_VIDEO_STANDARD_NTSC_M\n");
	printk(KERN_INFO "1: \t ADV7180_VIDEO_STANDARD_NTSC_443\n");
	printk(KERN_INFO "2: \t ADV7180_VIDEO_STANDARD_PAL_D\n");
	printk(KERN_INFO "3: \t ADV7180_VIDEO_STANDARD_PAL_M\n");
	printk(KERN_INFO "4: \t ADV7180_VIDEO_STANDARD_PAL_N_COMBO\n");
	printk(KERN_INFO "5: \t ADV7180_VIDEO_STANDARD_PAL_60\n");
	printk(KERN_INFO "6: \t ADV7180_VIDEO_STANDARD_SECAM_B\n");
	printk(KERN_INFO "7: \t ADV7180_VIDEO_STANDARD_SECAM_D\n");
	printk(KERN_INFO "8: \t ADV7180_VIDEO_STANDARD_NONE\n");
}

typedef enum _VIN_FORMAT {
	VIN_FORMAT_YUYV,
	VIN_FORMAT_UYVY,
	VIN_FORMAT_RGB32
} VIN_FORMAT;

typedef enum _COLOR_FORMAT {
	COLOR_FORMAT_RGB24,
	COLOR_FORMAT_RGB32,
	COLOR_FORMAT_YUY2,
	COLOR_FORMAT_UYVY,
	COLOR_FORMAT_I420
} COLOR_FORMAT;

typedef enum _COLOR_SPACE
{
	CS_UNKNOWN,
	CS_GRAY8,
	CS_RGB15,
	CS_RGB16,
	CS_RGB24,
	CS_RGB32,
	CS_ARGB32,
	CS_YUY2,
	CS_YUYV,
	CS_YVYU,
	CS_UYVY,
	CS_VYUY,
	CS_I420,
	CS_IYUV,
	CS_YV12
} COLOR_SPACE;

typedef enum _VINEX_FORMAT {
	VINEX_FORMAT_RGB32,
	VINEX_FORMAT_RGB24,
	VINEX_FORMAT_AYUV,
	VINEX_FORMAT_YUYV,
	VINEX_FORMAT_YVYU,
	VINEX_FORMAT_UYVY,
	VINEX_FORMAT_VYUY,
	VINEX_FORMAT_GRAY8
} VINEX_FORMAT;


typedef struct _VIDEO_SIGNAL_STATUS {
	int					nFrameRate;
	bool				bInterlaced;
	int					nHSyncPol;
	int					nVSyncPol;
	int					nVSyncLineCount;
	int					nFrameLineCount;
} VIDEO_SIGNAL_STATUS;


//add for app ioctl signal info 
/*
typedef struct _VIDEO_SIGNAL_INFO {
	bool			bHasSignal;
	int				cx;
	int 			cy;
	bool			bInterlaced;
	int 			format;
	bool			bPrescaled;
	int 			cxScaled;
	int				nFrameRate;
	int				nFrameDuration;	
	bool 			bHDCP;
}VIDEO_SIGNAL_INFO;
*/

typedef enum _VIDEO_TIMING_TYPE
{
	DM_ALL				= 0x3FF,
	DM_LEGACY			= 0x01,
	DM_DMT				= 0x02,
	DM_CEA				= 0x04,
	DM_GTF				= 0x08,
	DM_CVT				= 0x10,
	DM_CVT_RB			= 0x20,
	DM_CUSTOM			= 0x40,
	DM_DVI_HDMI			= 0x80,
	DM_PRESET			= 0x100,
	DM_FAILSAFE			= 0x200
} VIDEO_TIMING_TYPE;

typedef struct _VIDEO_TIMING_PARAMS
{
	VIDEO_TIMING_TYPE	type;
	int					cxTotal;
	int					cx;
	int					cy;
	int					xOffset;
	int					yOffset;
} VIDEO_TIMING_PARAMS;

typedef struct _VIDEO_RESOLUTION {
	int					cx;
	int					cy;
} VIDEO_RESOLUTION;


#define MAX_HDCAPTURE_TIMING	10

typedef enum {
	CAPTURE_STATE_NO_SIGNAL,
	CAPTURE_STATE_UNSUPPORTED_SIGNAL,
	CAPTURE_STATE_NORMAL
}CAPTURE_STATE;

typedef struct _VIDEO_STATUS {
	bool					bHasSignal;
	VIDEO_SIGNAL_STATUS		videoSignalStatus;
	bool					bHDMIMode;
	bool					bHDCPContent;
	int						nFrameDuration;
	int						cVideoTimingParams;
	VIDEO_TIMING_PARAMS		aVideoTimingParams[MAX_HDCAPTURE_TIMING];
	bool					bPresetPresent;
	VIDEO_TIMING_PARAMS		videoTimingPreset;
}VIDEO_STATUS;

typedef enum {
	MODE_CHANGE			= 0x01,
	TIMING_CHANGE		= 0x02,
	FORMAT_CHANGE		= 0x04,
	HORIZ_FLIP_CHANGE	= 0x08,
	AUTO_PHASE			= 0x10,
	AUTO_POSITION		= 0x20,
	PRESET_CHANGE		= 0x40,
	PRESCALE_CHANGE		= 0x80,
	EDID_CHANGE			= 0x100
}PENDING_PARAM_CHANGES;

typedef struct _PRESCALE_PARAMS {
	bool				bEnablePrescale;
	int					cxOut;
	int					cyOut;
	SCALEP_TYPE			scaleMode;
}PRESCALE_PARAMS;

#define HDCAPTURE_API_VER		1

typedef enum  
{
	HDCAPTURE_CAPS,							// All API Versions, GET
	HDCAPTURE_MODE_E,						//old is HDCAPTURE_MODE:: API V1, GET/SET
	HDCAPTURE_OUTPUT_FORMAT,				// API V1, GET
	HDCAPTURE_SIGNAL_STATUS,				// API V1, GET
	HDCAPTURE_TIMING_LIST,					// API V1, GET
	HDCAPTURE_PRESET_TIMING,				// API V1, GET/SET
	HDCAPTURE_TIMING_E,						// API V1, GET/SET
	HDCAPTURE_PHASE,						// API V1, GET/SET
	HDCAPTURE_TRIGGER_AUTO_POSITION,		// API V1, SET, NO PARAM
	HDCAPTURE_SCALE,						// API V1, GET/SET
	HDCAPTURE_DEINTERLACE,					// API V1, GET/SET
	HDCAPTURE_FLIP,							// API V1, GET/SET
	HDCAPTURE_COLOR_ADJUST,					// API V1, GET/SET
	HDCAPTURE_AUTO_DETECT_MODE,				// API V1, GET/SET
	HDCAPTURE_DEFAULT_TIMING				// API V1.1, GET
} HDCAPTURE;

typedef struct _HDCAPTURE_CAPS_S {
	uint32_t	dwAPIVersion;
	uint32_t	dwModeSupportMasks;
} HDCAPTURE_CAPS_S, *PHDCAPTURE_CAPS_S;

typedef struct _HDMICAPTURE_EDID_S {
	WORD			cbEDIDData;
	unsigned char *	abyEDIDData;
}HDMICAPTURE_EDID_S;

typedef enum _HDCAPTURE_MODE
{
	HDCAPTURE_MODE_DIGITAL,
	HDCAPTURE_MODE_HDMI_CH1,//add for 400 hdmi
	HDCAPTURE_MODE_RGB,
	HDCAPTURE_MODE_YPbPr,
	HDCAPTURE_MODE_CVBS,
	HDCAPTURE_MODE_SVideo,	

	HDCAPTURE_MODE_MIN		= HDCAPTURE_MODE_DIGITAL,
	HDCAPTURE_MODE_MAX		= HDCAPTURE_MODE_SVideo,
	HDCAPTURE_MODE_INVALID	= -1 
} HDCAPTURE_MODE;

typedef struct _HDCAPTURE_MODE_S {
	HDCAPTURE_MODE enumHDCaptureMode;
} HDCAPTURE_MODE_S, *PHDCAPTURE_MODE_S;

typedef struct _HDCAPTURE_OUTPUT_FORMAT_S {
	bool					bConnected;
	int						cx;
	int						cy;
	uint64_t				llFrameDuration;
	COLOR_SPACE				colorSpace;
} HDCAPTURE_OUTPUT_FORMAT_S, *PHDCAPTURE_OUTPUT_FORMAT_S;

typedef struct _HDCAPTURE_SIGNAL_STATUS_S {
	int			nSignalVersion;
	bool		bHasSignal;
	int			nFrameRate;
	bool		bInterlaced;
	int			nHSyncPol;
	int			nVSyncPol;
	int			nVSyncLineCount;
	int			nFrameLineCount;
	bool		bPresetPresent;
	bool		bHDMIMode;
	int			nHDMIAudioSampleRate;
	int			nFrameDuration;
} HDCAPTURE_SIGNAL_STATUS_S, *PHDCAPTURE_SIGNAL_STATUS_S;

typedef struct _HDCAPTURE_TIMING {
	//HDCAPTURE_TIMING_TYPE			type;
	VIDEO_TIMING_TYPE				type;
	int								cxTotal;
	int								cx;
	int								cy;
	int								xOffset;
	int								yOffset;
} HDCAPTURE_TIMING;

typedef struct _HDCAPTURE_TIMING_LIST_S{
	int							nSignalVersion;
	int							cHDCaptureTiming;
	HDCAPTURE_TIMING			aHDCaptureTiming[MAX_HDCAPTURE_TIMING];
} HDCAPTURE_TIMING_LIST_S, *PHDCAPTURE_TIMING_LIST_S;

typedef struct _HDCAPTURE_TIMING_S {
	int					nVersion;												
	HDCAPTURE_TIMING	hdCaptureTiming;
} HDCAPTURE_TIMING_S, *PHDCAPTURE_TIMING_S;

typedef struct _HDCAPTURE_PRESET_TIMING_S {
	int					nSignalVersion;			// GET/SET
	bool				bDeletePreset;			// SET
	HDCAPTURE_TIMING	hdCaptureTimingPreset;	// GET/SET
} HDCAPTURE_PRESET_TIMING_S, *PHDCAPTURE_PRESET_TIMING_S;

#define TRIGGER_AUTO_PHASE			0xFF

typedef struct _HDCAPTURE_PHASE_S {
	uint8_t			byPhase;
} HDCAPTURE_PHASE_S, *PHDCAPTURE_PHASE_S;

typedef struct _HDCAPTURE_SCALE_S {
	uint32_t		dwSupportMasks;
	SCALEP_TYPE		scaleType;
} HDCAPTURE_SCALE_S, *PHDCAPTURE_SCALE_S;

typedef struct _HDCAPTURE_DEINTERLACE_S {
	uint32_t			dwSupportMasks;
	DEINTERLACE_TYPE	deinterlaceType;
} HDCAPTURE_DEINTERLACE_S, *PHDCAPTURE_DEINTERLACE_S;

#define HDFF_HORIZONTAL_FLIP		0x01
#define HDFF_VERTICAL_FLIP			0x02

typedef struct _HDCAPTURE_FLIP_S {
	uint32_t	dwSupportMasks;
	uint32_t	dwFlags;
} HDCAPTURE_FLIP_S, *PHDCAPTURE_FLIP_S;

#define HDCAF_ALL					0xFF
#define HDCAF_RED_BRIGHTNESS		0x01
#define HDCAF_GREEN_BRIGHTNESS		0x02
#define HDCAF_BLUE_BRIGHTNESS		0x04
#define HDCAF_RED_CONTRAST			0x08
#define HDCAF_GREEN_CONTRAST		0x10
#define HDCAF_BLUE_CONTRAST			0x20

typedef struct _HDCAPTURE_COLOR_ADJUST_S {
	uint32_t	dwFlags;

	int			nRedBrightness;
	int			nGreenBrightness;
	int			nBlueBrightness;

	int			nRedContrast;
	int			nGreenContrast;
	int			nBlueContrast;
} HDCAPTURE_COLOR_ADJUST_S, *PHDCAPTURE_COLOR_ADJUST_S;

typedef struct _HDCAPTURE_AUTO_DETECT_MODE_S {
	bool	bAutoDetectMode;
} HDCAPTURE_AUTO_DETECT_MODE_S, *PHDCAPTURE_AUTO_DETECT_MODE_S;

typedef struct _HDCAPTURE_DEFAULT_TIMING_S {
	int					nSignalVersion;				
	uint8_t				byPhase;
	HDCAPTURE_TIMING	hdCaptureTiming;
} HDCAPTURE_DEFAULT_TIMING_S, *PHDCAPTURE_DEFAULT_TIMING_S;


typedef struct _VideoSignalInfo {
	bool 	bSingalValid;
	bool 	bSignalChanged;
	
	bool 	bNewImage;
	bool	bOverflow;
	bool	bUnderflow;
	
	int 	dwSrcWidth;
	int 	dwSrcHeight;
	int 	dwSrcfps;
	char	cSrcImageID;
}VideoSignalInfo;

typedef struct _VideoShowInfo{
	bool 	bBottomUp;
	int 	csOutput;
	u32		fourcc;
	
	long 	cxWidth;
	long 	cyHeight;
	long	depth;
}VideoShowInfo;

static inline u32 VinFormat2V4l2PixFormat(VIN_FORMAT format)
{
	u32 fmt;
	switch (format) {
		case VIN_FORMAT_YUYV:
			fmt = V4L2_PIX_FMT_YUYV;
			break;
		case VIN_FORMAT_UYVY:
			fmt = V4L2_PIX_FMT_UYVY;
			break;
		case VIN_FORMAT_RGB32:
			fmt = V4L2_PIX_FMT_RGB32;
			break;
		default :
			fmt = V4L2_PIX_FMT_YUYV;
	}
	return fmt;
}

static inline  unsigned int VinFormat2BPP(VIN_FORMAT format)
{
	unsigned int bpp;
	switch(format){
		case VIN_FORMAT_YUYV:
		case VIN_FORMAT_UYVY:
			bpp = 2;
			break;
		case VIN_FORMAT_RGB32:
			bpp = 4;
			break;
		default :
			bpp = 0;
	}
	return bpp;
}

static inline bool IsRGBColorSpace(COLOR_SPACE cs)
{
	switch (cs) {
	case CS_RGB15:
	case CS_RGB16:
	case CS_RGB24:
	case CS_RGB32:
	case CS_ARGB32:
		return true;
	default:
		return false;
	}
}

static inline int GetColorSpaceBpp(COLOR_SPACE cs)
{
	switch (cs) {
	case CS_RGB15:
	case CS_RGB16:
	case CS_YUY2:
	case CS_YUYV:
	case CS_YVYU:
	case CS_UYVY:
	case CS_VYUY:
		return 16;
	case CS_RGB24:
		return 24;
	case CS_RGB32:
	case CS_ARGB32:
		return 32;
	case CS_I420:
	case CS_IYUV:
	case CS_YV12:
		return 12;
	default:
		return 0;
	}
}

static inline bool IsSameColorSpace(COLOR_SPACE cs1,COLOR_SPACE cs2)
{
	return (cs1 == cs2) 
		|| ((cs1 == CS_YUY2 || cs1 == CS_YUYV) && (cs2 == CS_YUY2 || cs2 == CS_YUYV))
		|| ((cs1 == CS_I420 || cs1 == CS_IYUV) && (cs2 == CS_I420 || cs2 == CS_IYUV));
}

static inline int GetPixelAlignmentX(COLOR_SPACE cs)
{
	switch (cs) {
	case CS_RGB15:
	case CS_RGB16:
	case CS_RGB24:
	case CS_RGB32:
		return 1;

	case CS_YUY2:
	case CS_YUYV:
	case CS_YVYU:
	case CS_UYVY:
	case CS_VYUY:
		return 2;

	default:
		return 1;
	}
}

static inline int GetPixelAlignmentY(COLOR_SPACE cs)
{
	switch (cs) {
	case CS_I420:
	case CS_IYUV:
	case CS_YV12:
		return 2;

	default:
		return 1;
	}
}

static inline COLOR_SPACE VIFMT2CSIN(VIN_FORMAT fmt)
{
	switch(fmt){
	case VIN_FORMAT_YUYV:
		return CS_YUYV;
	case VIN_FORMAT_UYVY:
		return CS_UYVY;
	
	default:
		return CS_RGB32;
	}
}

static inline long CS2BITCOUNT(COLOR_SPACE cs)
{
	switch (cs) {
	case CS_RGB32:
		return 32;
	case CS_RGB24:
		return 24;
	case CS_YUYV:
	case CS_YVYU:
	case CS_UYVY:
	case CS_VYUY:
		return 16;
	default:
		return 0;
	}
}

static inline COLOR_SPACE VinexFormat2ColorSpace(VINEX_FORMAT format)
{
	switch (format) {
	case VINEX_FORMAT_RGB24:
		return CS_RGB24;
	case VINEX_FORMAT_RGB32:
		return CS_RGB32;
	case VINEX_FORMAT_YUYV:
		return CS_YUYV;
	case VINEX_FORMAT_YVYU:
		return CS_YVYU;
	case VINEX_FORMAT_UYVY:
		return CS_UYVY;
	case VINEX_FORMAT_VYUY:
		return CS_VYUY;
	case VINEX_FORMAT_GRAY8:
		return CS_GRAY8;
	default:
		return CS_YUYV;
	}	
}

static inline u32 VinexFormat2Fourcc(VINEX_FORMAT format)
{
	switch (format) {
	case VINEX_FORMAT_RGB24:
		return V4L2_PIX_FMT_RGB24;
	case VINEX_FORMAT_RGB32:
		return V4L2_PIX_FMT_RGB32;
	case VINEX_FORMAT_YUYV:
		return V4L2_PIX_FMT_YUYV;
	case VINEX_FORMAT_YVYU:
		return V4L2_PIX_FMT_YVYU;
	case VINEX_FORMAT_UYVY:
		return V4L2_PIX_FMT_UYVY;
	case VINEX_FORMAT_VYUY:
		return V4L2_PIX_FMT_VYUY;
	case VINEX_FORMAT_GRAY8:
		return V4L2_PIX_FMT_GREY;
	default:
		return V4L2_PIX_FMT_YUYV;
	}	
}

static inline VINEX_FORMAT ColorSpace2Format(COLOR_SPACE csIn)
{
	switch (csIn) {
	case CS_RGB24:
		return VINEX_FORMAT_RGB24;
	case CS_RGB32:
		return VINEX_FORMAT_RGB32;
	case CS_YUY2:
	case CS_YUYV:
		return VINEX_FORMAT_YUYV;
	case CS_YVYU:
		return VINEX_FORMAT_YVYU;
	case CS_UYVY:
		return VINEX_FORMAT_UYVY;
	case CS_VYUY:
		return VINEX_FORMAT_VYUY;
	case CS_I420:
	case CS_YV12:
	case CS_IYUV:
		return VINEX_FORMAT_YUYV;
	case CS_GRAY8:
		return VINEX_FORMAT_GRAY8;
	default:
		return VINEX_FORMAT_YUYV;
	}
}


static inline VIN_FORMAT V4L2PixFormat2VinFormat(u32 pixelformat)
{
	VIN_FORMAT fmt;
	switch (pixelformat) {
		case V4L2_PIX_FMT_YUYV:
		case V4L2_PIX_FMT_YVYU:
			fmt = VIN_FORMAT_YUYV;
			break;
		case V4L2_PIX_FMT_UYVY:
		case V4L2_PIX_FMT_VYUY:
			fmt = VIN_FORMAT_UYVY;
			break;
		case V4L2_PIX_FMT_BGR32:
		case V4L2_PIX_FMT_RGB32:
			fmt = VIN_FORMAT_RGB32;
			break;
		default:
			fmt = VIN_FORMAT_YUYV;
	}
	return fmt;
}

static inline COLOR_SPACE V4L2FMT2CSOUT(uint32_t pixelformat)
{
	switch(pixelformat) {
	case V4L2_PIX_FMT_GREY:
		return CS_GRAY8;
	case V4L2_PIX_FMT_RGB555:
	case V4L2_PIX_FMT_RGB555X:
		return CS_RGB15;
	case V4L2_PIX_FMT_RGB565:
	case V4L2_PIX_FMT_RGB565X:
		return CS_RGB16;
	case V4L2_PIX_FMT_BGR24:
	case V4L2_PIX_FMT_RGB24:
		return CS_RGB24;
	case V4L2_PIX_FMT_BGR32:
	case V4L2_PIX_FMT_RGB32:
		return CS_RGB32;
	case V4L2_PIX_FMT_YUYV:
		return CS_YUYV;
	case V4L2_PIX_FMT_YVYU:
		return CS_YVYU;
	case V4L2_PIX_FMT_UYVY:
		return CS_UYVY;
	case V4L2_PIX_FMT_VYUY:
		return CS_VYUY;		
		
	default:
		return CS_UNKNOWN;
	}
}

