#pragma once

#include <sound/core.h>
#include <sound/pcm.h>
#include <sound/pcm_params.h>
#include <sound/initval.h>
#include <sound/control.h>
#include "OSAbstract/OSAbstract.h"

typedef struct _XIAdrv {
	struct list_head	list;
	struct snd_card		*card;
	struct snd_pcm		*pcm;	
	struct snd_pcm_substream 	*substream;
	void 				*dev;
	
	//thread info
	struct task_struct 	*pthread;
	wait_queue_head_t	wq;
	atomic_t			trigger;

	//control info
	unsigned int 	channal;
	uint8_t 		volume[2];

	spinlock_t			ring_lock;
	uint32_t			ring_wpos_byframes;
	uint32_t			ring_size_byframes;
	uint32_t			period_size_byframes;
	uint32_t			period_used_byframes;

	//add for ROMID
	unsigned char 	*romid;
	unsigned int 	rlg;
}XIAdrv;

int xi_alsa_init(void *dev);
int xi_alsa_release(void *dev);
void xi_alsa_suspend(void *dev);
void xi_alsa_resume(void *dev);
