#pragma once

#include <linux/mutex.h>
#include <linux/ioctl.h>
#include <linux/cdev.h>

#include "OSAbstract/OSAbstract.h"

#define XI_AUDIO_IOC_MAGIC   'a'
#define XI_AUDIO_IOCSTART	_IOWR(XI_AUDIO_IOC_MAGIC,  0, int)
#define XI_AUDIO_IOCSTOP	_IOWR(XI_AUDIO_IOC_MAGIC,  1, int)
#define XI_AUDIO_IOCPOST	_IOWR(XI_AUDIO_IOC_MAGIC,  2, int)

#define XI_AUDIO_IOCGVLINE	_IOWR(XI_AUDIO_IOC_MAGIC,  3, int)
#define XI_AUDIO_IOCGVHDMI	_IOWR(XI_AUDIO_IOC_MAGIC,  4, int)
#define XI_AUDIO_IOCSVLINE	_IOWR(XI_AUDIO_IOC_MAGIC,  5, int)
#define XI_AUDIO_IOCSVHDMI	_IOWR(XI_AUDIO_IOC_MAGIC,  6, int)

#define XI_AUDIO_IOC_MAXNR   	7

typedef struct _audio_param {
	ssize_t bsize;
	int 	channal;
	int 	bps;
}audio_param;

typedef struct _xi_audio_dev 
{ 
	struct cdev 		cdev;   
	void *				dev;
	int 				channal;
	int 				major;
	atomic_t			start;
	
	wait_queue_head_t	wq;	
	struct task_struct 	*pthread;
	
	unsigned char 		*romid;
	unsigned int 		rlg;
	
	
	struct mutex 		bmutex;
	unsigned char 		*buf;
	signed int 			bsize;
	atomic_t 			wpos;
	int 				rpos;
	
	uint8_t 			volume[2];
	uint8_t				vhdmi[2];
	
	struct list_head	list;
}xi_audio;

int xi_audio_init(void *dev);
int xi_audio_release(void *dev);
void xi_audio_suspend(void *dev);
void xi_audio_resume(void *dev);
